           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |             December 2004 (modified)      |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM11_Seq_Sys = DM10_Seq_Sys:

(*****************************************************************

         1. proves lemma for Seq =F Sys
         2.
         3. 
         4. 

 *****************************************************************)

(*** Seq_TH0_WR1 ***)

lemma Seq_TH0_WR1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_TH0_WR1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_TH0_WR1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_TH0_WR1

(*** Seq_TH0_WR1 ***)

lemma Seq_WR0_TH1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_WR0_TH1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_WR0_TH1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (case_tac "ODD (n div 2)")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_WR0_TH1

end
