           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |             December 2004 (modified)      |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM05_para = DM04_para:

(*****************************************************************

         1. expands parallel operators in Sys
         2.
         3. 
         4. 

 *****************************************************************)

(*** WR0 VAR Back1 step 5 ***)

lemma WR0_VAR_Back1: 
  "EVEN n ==>
   LET SysDef IN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
   =F
   LET SysDef IN ? x:{WR0 (n div 2), Back1}
      -> IF (x = WR0 (n div 2))
            THEN (<TH0>  |[CH0]| <VAR (n div 2)> |[CH1]| Back1 -> <TH1>)
            ELSE (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF WR0_VAR_Back1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF WR0_VAR_Back1[simplified]]

(*** Back0 VAR WR1 step 5 ***)

lemma Back0_VAR_WR1: 
  "ODD n ==>
   LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n> 
                                 |[CH1]| WR1 (3 * n + 1) -> <TH1>)
   =F
   LET SysDef IN ? x:{WR1 (3 * n + 1), Back0} 
   -> IF (x = WR1 (3 * n + 1))
         THEN (Back0 -> <TH0> |[CH0]| <VAR (3 * n + 1)> |[CH1]| <TH1>)
         ELSE (<TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF Back0_VAR_WR1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF Back0_VAR_WR1[simplified]]

end
